## dde-network-core 2.0.71

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION "2.0.18" CACHE STRING "define project version")
project(dde-network-core
  VERSION ${VERSION}
  DESCRIPTION "DDE Network Core"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dde-network-core"
  LANGUAGES CXX C
)

option(ENABLE_DEEPIN_NMQT "enable nmqt patch on deepin" OFF)
option(BUILD_TESTS "Build unit tests" OFF)

set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src-old")
set(DDE-Network-Core_LIBRARIES  dde-network-core)

find_package(PkgConfig REQUIRED)
pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
include_directories(${LibNM_INCLUDE_DIRS})

pkg_check_modules(Gio REQUIRED gio-2.0)
include_directories(${Gio_INCLUDE_DIRS})

pkg_search_module(GLIB REQUIRED glib-2.0)
include_directories(${GLIB_INCLUDE_DIRS})
link_directories(${GLIB_LIBRARY_DIRS})

if (QT_DEBUG)
    message(" KF5_QT_INCLUDE_DIRS : " ${KF5_QT_INCLUDE_DIRS})
    message(" GLIB_INCLUDE_DIRS :" ${GLIB_INCLUDE_DIRS})
    message(" CMAKE_CURRENT_SOURCE_DIR: " ${CMAKE_CURRENT_SOURCE_DIR})
    message(STATUS ${result})
endif()

if (ENABLE_DEEPIN_NMQT)
    add_definitions(-DUSE_DEEPIN_NMQT)
endif()

message(STATUS DEEPIN_NMQT_TEST ": ${DEEPIN_NMQT_TEST}")

set(INTERFACE_VERSION "2.0")
add_definitions(-DINTERFACE_VERSION="${INTERFACE_VERSION}")
message("Interface Version: " ${INTERFACE_VERSION})
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr")
endif()
include(GNUInstallDirs)

add_subdirectory("src")
# add_subdirectory("src-old")
# add_subdirectory("dcc-network-plugin")
add_subdirectory("dcc-network")
if (BUILD_TESTS)
    add_subdirectory("tests")
endif()
# add_subdirectory("example")
add_subdirectory("dock-network-plugin")
add_subdirectory("dss-network-plugin")
# add_subdirectory("dss_example")
#add_subdirectory("dock-example")
add_subdirectory("network-service-plugin")

=== dcc-network/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dcc-network-plugin")

project(${PLUGIN_NAME})

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 指定所有源码文件
# file(GLOB_RECURSE SRCS "*.h"
#     "*.cpp"
# )

# 指定要用到的库
# -DQT_MAJOR_VERSION=6
# find_package(QT NAMES Qt6 Qt5)
# set(QT_MAJOR_VERSION 6)
# set(QT_DEFAULT_MAJOR_VERSION 6)
# find_package(Qt6 REQUIRED COMPONENTS Quick)
find_package(Qt6 COMPONENTS Core Gui DBus Network LinguistTools REQUIRED)
find_package(DdeControlCenter REQUIRED)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)
#pkg_check_modules(DDE-Network-Core REQUIRED dde-network-core)


set(DccNetwork_Name network)
file(GLOB_RECURSE DccNetwork_SRCS
        "*.cpp"
        "*.h"
        "../net-view/operation/*.cpp"
        "../net-view/operation/*.h"
        "../net-view/window/qrc/network.qrc"
        # "qrc/systeminfo.qrc"
)

add_library(${DccNetwork_Name} MODULE
        ${DccNetwork_SRCS}
)

target_include_directories(${DccNetwork_Name} PUBLIC
    Dde::Control-Center
    "../net-view/operation"
    "../src"
)

set(DccNetwork_Libraries
        Qt6::DBus
        Qt6::Network
        Qt6::Gui
        # Qt6::Quick
        Dtk6::Core
        KF6::NetworkManagerQt
        Dde::Control-Center
        dde-network-core6
)

target_link_libraries(${DccNetwork_Name} PRIVATE
        ${DccNetwork_Libraries}
)

dcc_install_plugin(NAME ${DccNetwork_Name} TARGET ${DccNetwork_Name})

dcc_handle_plugin_translation(NAME ${DccNetwork_Name} )

=== dock-example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dock_example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DtkCore REQUIRED)
find_package(DtkWidget REQUIRED)

set(DTKCORE_INCLUDE_DIR DTKCORE_INCLUDE_DIRS)

find_package(DdeDock REQUIRED)
find_package(PkgConfig REQUIRED)

aux_source_directory(../dock-network-plugin DOCKPLUGINDIR)
aux_source_directory(../common-plugin/* COMMONPLUGINS)

aux_source_directory(. COMPILEFILES)
file(GLOB_RECURSE QRCFILES "../common-plugin/network.qrc"
    "../common-plugin/resources/common/*.svg"
    "../common-plugin/resources/wired/*.svg"
    "../common-plugin/resources/wireless/*.svg"
    "../common-plugin/resources/wireless6/*.svg")

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

file(GLOB_RECURSE COMMONPLUGINS_SRCS
    ../common-plugin/*
    ../dss-network-plugin/dockpopupwindow.h
    ../dss-network-plugin/dockpopupwindow.cpp
)
add_executable(${PROJECT_NAME}
    ${COMPILEFILES}
    ${DOCKPLUGINDIR}
    ${COMMONPLUGINS_SRCS}
    ${QRCFILES})

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

foreach(LETTER ${TRY_KF5_LIBRARIES})
    if (NOT KF5_QT_LIBRARIES)
        get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
    endif()
endforeach()

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

target_include_directories(${PROJECT_NAME} PUBLIC
    ../dock-network-plugin
    ../common-plugin
    ../common-plugin/widgets
    ../common-plugin/item
    ../common-plugin/resources/common/
    ../common-plugin/resources/wired/
    ../common-plugin/resources/wireless/
    ../dss-network-plugin
    ${DdeControlCenter_INCLUDE_DIR}
    ${DDE_DOCK_INCLUDE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5Widget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    #${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ${DDE-Network-Core_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${DDE_DOCK_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    #${LibNM_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${DDE-Network-Core_LIBRARIES}
)

add_custom_command(
    OUTPUT path.pb.cc path.pb.h
    COMMAND protoc
    ARGS --cpp_out . ${CMAKE_CURRENT_SOURCE_DIR}/path.proto -I ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS path.proto)

=== dock-network-plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "dock-network-plugin")

set(QT_NS Qt6)
set(DTK_NS Dtk6)

project(${PLUGIN_NAME})
include(GNUInstallDirs)
# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS
    "networkplugin.h"
    "networkplugin.cpp"
    "quickpanelwidget.h"
    "quickpanelwidget.cpp"
    "dockcontentwidget.h"
    "../net-view/*.h"
    "../net-view/*.cpp"
    "widget/jumpsettingbutton.h"
    "widget/jumpsettingbutton.cpp"
    "widget/commoniconbutton.h"
    "widget/commoniconbutton.cpp"
)

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

find_package(${QT_NS} COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} REQUIRED COMPONENTS Widget)
find_package(KF6NetworkManagerQt REQUIRED)
find_package(DdeDock REQUIRED)

#if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
#endif()

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../net-view/window/qrc/network.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../dde-dock)

file(GLOB TS_FILES "translations/*.ts")
qt_add_translations(${PLUGIN_NAME}_language
    TS_FILES ${TS_FILES}
    SOURCES ${SRCS}
    LUPDATE_OPTIONS -no-obsolete -no-ui-lines -locations none
    QM_FILES_OUTPUT_VARIABLE QM_FILES
)
add_custom_target(${PLUGIN_NAME}_language ALL DEPENDS ${QM_FILES})
# get_target_property(KF6_QT_INCLUDE_DIRS KF6::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DTK_NS}::Widget
    ${QT_NS}::Dbus
    ${QT_NS}::Network
    KF6::NetworkManagerQt
    # "../../../interfaces"
    "../net-view/operation"
    "../net-view/window"
    "../src"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${QT_NS}::Widgets
    ${QT_NS}::DBus
    ${QT_NS}::Network
    ${DTK_NS}::Widget
    KF6::NetworkManagerQt
    dde-network-core6
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/system-trays)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)
# 安装显示在控制中心-个性化-任务栏-插件区域的图标
install(FILES "resources/dcc-network.dci" DESTINATION share/dde-dock/icons/dcc-setting)

=== dss-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dss-network-plugin")

project(${PLUGIN_NAME})

include(GNUInstallDirs)
# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)
set(NET_USE_NOTIFICATION ON)

file(GLOB_RECURSE SRCS "networkmodule.h" "networkmodule.cpp"  "../net-view/*.h" "../net-view/*.cpp")

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

find_package(Qt6 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
# find_package(Qt5Svg REQUIRED)
find_package(Dtk6 COMPONENTS Widget REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)
find_package(DdeSessionShell REQUIRED)

# if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
#     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
# endif()

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")

if (NET_USE_NOTIFICATION)
    add_definitions(-DNET_USE_NOTIFICATION)
    file(GLOB_RECURSE NOTIFICATION_SRCS "notification/*.h" "notification/*.cpp")
    set(SRCS ${SRCS} ${NOTIFICATION_SRCS})
endif()

file(GLOB TS_FILES "translations/*.ts")
qt_add_translations(${TARGET_NAME}_language
    TS_FILES ${TS_FILES}
    SOURCES ${SRCS}
    LUPDATE_OPTIONS -no-obsolete -no-ui-lines -locations none
    QM_FILES_OUTPUT_VARIABLE QM_FILES
)

add_custom_target(${TARGET_NAME}_language ALL DEPENDS ${QM_FILES})
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../net-view/window/qrc/network.qrc)

target_include_directories(${PLUGIN_NAME} PUBLIC
    Dtk6::Widget
    Qt6::DBus
    Qt6::Network
    Qt6::Widgets
    ${DDESESSIONSHELL_INCLUDE_DIR}
    KF6::NetworkManagerQt
    "../net-view/operation"
    "../net-view/window"
    "../src"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Dtk6::Widget
    Qt6::DBus
    Qt6::Network
    Qt6::Widgets
    dde-network-core6
    KF6::NetworkManagerQt
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)

install(FILES 50-dss-network-plugin.rules DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/rules.d)

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(DdeControlCenter REQUIRED)
find_package(PkgConfig REQUIRED)

aux_source_directory(../dcc-network-plugin DCCPLUGINDIR)
aux_source_directory(../dcc-network-plugin/window DCCPLUGINWINDOWDIR)
aux_source_directory(../dcc-network-plugin/sections DCCPLUGINSECTIONS)
aux_source_directory(../dcc-network-plugin/sections/vpn DCCPLUGINSECTIONSVPN)
aux_source_directory(../dcc-network-plugin/settings DCCPLUGINSETTINGS)
aux_source_directory(../dcc-network-plugin/settings/vpn DCCPLUGINVPNSETTINGS)
aux_source_directory(../dcc-network-plugin/themes DCCPLUGINTHEMES)

file(GLOB_RECURSE QRCFILE "./example.qrc"
    "../dcc-network-plugin/icons/dcc-network-plugin.qrc"
    "../dcc-network-plugin/icons/actions/*.svg"
    "../dcc-network-plugin/icons/icons/*.svg")

set(COMPILEFILES
    ./networkhandler.h
    ./networkhandler.cpp
    ./moduledatamodel.h
    ./moduledatamodel.cpp
    ./main.cpp
    ./dccplugintestwidget.h
    ./dccplugintestwidget.cpp)

file(GLOB_RECURSE DCCPLUGINSRCS
    "../dcc-network-plugin/*.h"
    "../dcc-network-plugin/*.cpp"
    "../dcc-network-plugin/icons/*"
)
#message(${DCCPLUGINDIR})

#list(REMOVE_ITEM NETWORKDIR "../dde-network-core/debian")

add_executable(${PROJECT_NAME}
    ${COMPILEFILES}
    ${DCCPLUGINSRCS}
    ${REALIZEDIR}
    ${QRCFILE})

find_package(Qt5 COMPONENTS Core DBus Concurrent Network REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DtkWidget REQUIRED)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

foreach(LETTER ${TRY_KF5_LIBRARIES})
    if (NOT KF5_QT_LIBRARIES)
        get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
    endif()
endforeach()

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

target_include_directories(${PROJECT_NAME} PUBLIC
    ../dcc-network-plugin
    ../dcc-network-plugin/window
    ../dcc-network-plugin/operation
    ${DdeControlCenter_INCLUDE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5Widget_INCLUDE_DIRS}
    Qt5::Concurrent
    ${QGSettings_INCLUDE_DIRS}
    #${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ${DDE-Network-Core_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${DdeControlCenter_LIBRARIES}
    ${DCC_INTERFACE_LIBRARIES}
    ${DCC_WIDGETS_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    Qt5::Concurrent
    #${LibNM_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${DDE-Network-Core_LIBRARIES}
)

add_custom_command(
    OUTPUT path.pb.cc path.pb.h
    COMMAND protoc
    ARGS --cpp_out . ${CMAKE_CURRENT_SOURCE_DIR}/path.proto -I ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS path.proto)

=== network-service-plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set(BIN_NAME "network-service")

project(${BIN_NAME})

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

include(GNUInstallDirs)
file(GLOB_RECURSE SRCS "src/*.h" "src/*.cpp")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    ADD_DEFINITIONS(-DQM_FILES_DIR="${CMAKE_BINARY_DIR}/network-service-plugin")
else()
    ADD_DEFINITIONS(-DQM_FILES_DIR="/usr/share/deepin-service-manager/network-service/translations")
endif()
set(QT_NS 6)
set(DTK_NS Dtk6)

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

find_package(Qt${QT_NS} COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(KF${QT_NS}NetworkManagerQt REQUIRED)
find_package(${DTK_NS} COMPONENTS Core REQUIRED)

pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
pkg_check_modules(QGSettings REQUIRED gsettings-qt6)

add_library(${BIN_NAME} MODULE
    ${SRCS}
)

target_include_directories(${BIN_NAME} PUBLIC
  Qt${QT_NS}::Core
  Qt${QT_NS}::DBus
  Qt${QT_NS}::Network
  KF${QT_NS}::NetworkManagerQt
  ${DTK_NS}::Core
  ${QGSettings_INCLUDE_DIRS}
  src
  src/system
  src/session
  src/utils
  src/accountnetwork/system
  src/accountnetwork/system/accountnetwork
  src/accountnetwork/session/
  src/accountnetwork/session/accountnetwork
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt${QT_NS}::Core
  Qt${QT_NS}::DBus
  Qt${QT_NS}::Network
  KF${QT_NS}::NetworkManagerQt
  ${DTK_NS}::Core
  ${QGSettings_LIBRARIES}
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/system/)
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/user/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/src/system/plugin-system-network.json ${CMAKE_BINARY_DIR}/share/system/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/src/session/plugin-session-network.json ${CMAKE_BINARY_DIR}/share/user/)
else()
    # just need this in your project
    install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/system/plugin-system-network.json DESTINATION share/deepin-service-manager/system/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/session/plugin-session-network.json DESTINATION share/deepin-service-manager/user/)
endif()

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/system/deepin.dde.daemon.conf DESTINATION /etc/NetworkManager/conf.d/)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/system/org.deepin.service.SystemNetwork.conf DESTINATION share/dbus-1/system.d/)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/session/org.deepin.service.SessionNetwork.conf DESTINATION share/dbus-1/system.d/)

# dde-network-secret-dialog属于network-service-plugin项目，翻译文件放一起
file(GLOB_RECURSE ALL_SRCS "*.h" "*.cpp")
file(GLOB TS_FILES "translations/*.ts")
qt_add_translations(${BIN_NAME}_language
    TS_FILES ${TS_FILES}
    SOURCES ${ALL_SRCS}
    LUPDATE_OPTIONS -no-obsolete -no-ui-lines -locations none
    QM_FILES_OUTPUT_VARIABLE QM_FILES
)
add_custom_target(${BIN_NAME}_language ALL DEPENDS ${QM_FILES})
# 安装.qm文件
install(FILES ${QM_FILES} DESTINATION share/deepin-service-manager/network-service/translations/)

add_subdirectory("dde-network-secret-dialog")

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION "3.0.0" CACHE STRING "define project version")
project(dde-network-core6)

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

include(GNUInstallDirs)

file(GLOB_RECURSE SOURCEFILES "*.h" "*.cpp")

add_library(${PROJECT_NAME} SHARED ${SOURCEFILES})

find_package(Qt6 COMPONENTS Core DBus Network Gui LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)

pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)

file(GLOB TS_FILES "translations/*.ts")

qt_add_translation(QM_FILES ${TS_FILES})
add_custom_target(networktranslations ALL DEPENDS ${QM_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC
    dbus
    impl
    impl/networkmanager
    impl/serviceinter
    Qt6::Core
    Qt6::DBus
    Qt6::Network
    Qt6::Gui
    Dtk6::Core
    KF6::NetworkManagerQt
    PkgConfig::LibNM
)

message(STATUS ${LibNM_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} PRIVATE
    Qt6::Core
    Qt6::DBus
    Qt6::Network
    Qt6::Gui
    Dtk6::Core
    KF6::NetworkManagerQt
    PkgConfig::LibNM
    udev
)

configure_file(dde-network-core.pc.in ../dde-network-core.pc @ONLY)

set(INTERFACEFILES
    impl/dslcontroller.h
    impl/hotspotcontroller.h
    impl/vpncontroller.h
    networkconst.h
    networkcontroller.h
    networkdetails.h
    networkdevicebase.h
    proxycontroller.h
    wireddevice.h
    wirelessdevice.h)

set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    # OUTPUT_NAME dde-network-core
    # EXPORT_NAME Network-Core
)

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES ${INTERFACEFILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libddenetworkcore)
install(FILES ../config/org.deepin.dde.network.json DESTINATION ${CMAKE_INSTALL_DATADIR}/dsg/configs/org.deepin.dde.network)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-network-core/translations)

=== network-service-plugin/dde-network-secret-dialog/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE Dnetwork_Secret_Dialog_SRCS
    "src/*.h"
    "src/*.cpp"
)

list(REMOVE_ITEM Dnetwork_Secret_Dialog_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/src/main.cpp")

set(QT_VERSION_MAJOR 6)
set(DTK_VERSION_MAJOR 6)
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget)

set(Dmemory_Warning_Dialog_Includes
    Dtk${DTK_VERSION_MAJOR}::Widget
    Qt${QT_VERSION_MAJOR}::Widgets
)
set(Dnetwork_Secret_Dialog_Libraries
    Dtk${DTK_VERSION_MAJOR}::Widget
    Qt${QT_VERSION_MAJOR}::Widgets
)

add_subdirectory("src")
if (BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== network-service-plugin/dde-network-secret-dialog/src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(Dnetwork_Secret_Dialog_Name dde-network-secret-dialog)

add_executable(${Dnetwork_Secret_Dialog_Name}
    ${Dnetwork_Secret_Dialog_SRCS}
    main.cpp
    qrc/dde-network-secret-dialog.qrc
)

target_include_directories(${Dnetwork_Secret_Dialog_Name} PUBLIC
    ${Dnetwork_Secret_Dialog_Includes}
)

target_link_libraries(${Dnetwork_Secret_Dialog_Name} PRIVATE
    ${Dnetwork_Secret_Dialog_Libraries}
)

## bin
set(DAEMON_LIB_PATH "lib/deepin-daemon" CACHE STRING "daemon lib path")
install(TARGETS ${Dnetwork_Secret_Dialog_Name} DESTINATION ${DAEMON_LIB_PATH})

=== network-service-plugin/dde-network-secret-dialog/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(UT_Dnetwork_Secret_Dialog_Name ut-dnetwork-secret-dialog)

set(Test_Libraries
    -lpthread
    -lgcov
    -lgtest
    -lgmock
)

file(GLOB_RECURSE UT_Dnetwork_Secret_Dialog_SRCS
    "*.h"
    "*.cpp"
)

add_executable(${UT_Dnetwork_Secret_Dialog_Name}
    ${Dnetwork_Secret_Dialog_SRCS}
    ${UT_Dnetwork_Secret_Dialog_SRCS}
)

# 用于测试覆盖率的编译条件
target_compile_options(${UT_Dnetwork_Secret_Dialog_Name} PRIVATE -fprofile-arcs -ftest-coverage)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif()

target_include_directories(${UT_Dnetwork_Secret_Dialog_Name} PUBLIC
    ${Dnetwork_Secret_Dialog_Includes}
    ../src/
)

target_link_libraries(${UT_Dnetwork_Secret_Dialog_Name} PRIVATE
    ${Dnetwork_Secret_Dialog_Libraries}
    ${Test_Libraries}
)

=== debian/changelog ===
dde-network-core (2.0.71) unstable; urgency=medium

  * fix: Modify DNS name
  * fix: disable thousands separator in numeric input fields
  * i18n: Updates for project Deepin Desktop Environment (#411)
  * fix: Move dnetwork-secret-dialog from dde-session-ui
  * fix: Add icon resources

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 23 Oct 2025 16:00:16 +0800

dde-network-core (2.0.70) unstable; urgency=medium

  * fix: Add CancelGetsSecrets processing
  * fix: add comprehensive wireless network icons
  * fix: Update translation
  * [dde-network-core] Updates for project Deepin Desktop Environment
    (#405)
  * fix: Add switch button
  * fix: depends on dnsmasq-base
  * fix: Modify disable network error issues

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 16 Oct 2025 20:55:18 +0800

dde-network-core (2.0.69) unstable; urgency=medium

  * feat: Update translation
  * [dde-network-core] Updates for project Deepin Desktop Environment
    (#401)
  * feat: Migrate network-related code from dde-daemon

 -- YeShanShan <yeshanshan@uniontech.com>  Fri, 10 Oct 2025 17:26:00 +0800

dde-network-core (2.0.68) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#399)
  * fix: prevent DNS assignment in disabled network modes
  * fix: 网络图标展示为黑色
  * fix: update MTU configuration with valid range

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 04 Sep 2025 20:19:34 +0800

dde-network-core (2.0.67) unstable; urgency=medium

  * fix: allow empty IP list in manual mode and emit edit signals

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 21 Aug 2025 19:49:26 +0800

=== debian/control ===
Source: dde-network-core
Section: libs
Priority: optional
Maintainer: donghualin <donghualin@uniontech.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libglib2.0-dev (>= 2.32),
               pkg-config,
               libgtest-dev,
               dde-control-center-dev,
               dde-tray-loader-dev,
               dde-session-shell-dev,
               libudev-dev,               
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               libdtk6core-dev,
               libdtk6widget-dev,
               libgsettings-qt6-dev,
               libkf6networkmanagerqt-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://gerrit.uniontech.com/admin/repos/dde-network-core
Vcs-Browser: https://gerrit.uniontech.com/admin/repos/dde-network-core

Package: libdde-network-core
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},deepin-service-plugin-network,dnsmasq-base
Description: the library of network
 libdde-network-core module

Package: libdde-network-core-dev
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
Description: the interface of networkcode,used for developers
 libdde-network-core-dev module

Package: dcc-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},network-manager-integration-plugins,libdde-network-core (= ${binary:Version})
Description: the plugin of network for dde control center
 dcc-network-plugin module

Package: dock-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
Description: the plugin of network for dde-dock
 dock-plugin module

Package: dss-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
Description: the plugin of network for dde-lock
 dss-network-plugin module

Package: deepin-service-plugin-network
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},curl
Description: the plugin of network service for deepin-service-manager
 deepin-service-plugin-network module

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

export QT_SELECT = qt5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall
export DEB_CXXFLAGS_MAINT_APPEND = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E

DISTRO = $(shell lsb_release -is)
ifeq ($(DISTRO),Deepin)
	ENABLE_DEEPIN_NMQT=ON
else
	ENABLE_DEEPIN_NMQT=OFF
endif

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
%:
	dh $@ --parallel
override_dh_auto_configure:
	dh_auto_configure -- -DVERSION=$(PACK_VER) -DENABLE_DEEPIN_NMQT=${ENABLE_DEEPIN_NMQT}

## dde-network-core 2.0.74

=== debian/changelog ===
dde-network-core (2.0.74) unstable; urgency=medium

  * fix: resolve WiFi connection notification issue on login screen
  * fix: fix concurrent password request handling issue

 -- xionglinlin <xionglinlin@uniontech.com>  Thu, 13 Nov 2025 19:55:40 +0800

dde-network-core (2.0.73) unstable; urgency=medium

  * fix: Modifying text beyond the scope of the control
  * fix: Enterprise network processes connections based on configuration
  * fix: Security options are given default values based on
    configuration items
  * fix: The control resizes based on its content
  * i18n: Updates for project Deepin Desktop Environment (#421)
  * fix: Obtain password only during user activity

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 06 Nov 2025 16:25:21 +0800

dde-network-core (2.0.72) unstable; urgency=medium

  * fix: Add network OSD processing
  * fix: Error in obtaining VPN password modification
  * fix: fix MTU input formatting and change detection

 -- Robertkill <lvpeilong@uniontech.com>  Thu, 30 Oct 2025 19:51:50 +0800
